<script setup lang="ts">
import Flex from "@/components/atoms/container/Flex.vue";
import {useRepositoryImportModalStore} from "@/stores/Repository/RepositoryImportModalStore";
import type Repository from "@/entities/Repository/Repository";
import SearchRepositoryByNameForm from "@/components/organisms/form/Repository/SearchRepositoryByNameForm.vue";
import {RepositoryApiHandler} from "@/handlers/RepositoryApiHandler";
import RepositoryImportLine from "@/components/organisms/list/Repository/RepositoryImportLine.vue";
import {useSnackbarStore} from "@/stores/Snackbar/SnackbarStore";

const repositoryImportModal = useRepositoryImportModalStore();
const snackbarStore = useSnackbarStore();

const search = () => {
  repositoryImportModal.showLoader = true;
  const repositoryHandler = new RepositoryApiHandler();

  repositoryHandler.getRepositoriesFromBasedCode(
      repositoryImportModal.basedCode,
      repositoryImportModal.token,
      repositoryImportModal.host,
      repositoryImportModal.filterByName
  ).then((foundRepositories: Array<Repository>) => {
    repositoryImportModal.repositories = foundRepositories;
  }).catch(
      snackbarStore.createMessagesFromError
  ).finally(() => {
    repositoryImportModal.showLoader = false;
  });
}

const repositoryHandler = new RepositoryApiHandler();

</script>

<template>
  <Flex class="flex-col gap-content h-full">
    <SearchRepositoryByNameForm
        v-model:search="repositoryImportModal.filterByName"
        :afterSubmitCallback="search"
    />
    <hr/>
    <Flex class="flex-col gap-content overflow-auto">
      <RepositoryImportLine
          :key="repository.code"
          :repository="repository" v-for="(repository) of repositoryImportModal.repositories"
          :onImport="() => {
            repositoryImportModal.showLoader = true;
            repositoryHandler
              .create(repository)
              .then((createdRepository: Repository) => {
                repositoryImportModal.importedRepository = createdRepository;
                repositoryImportModal.nextView();
              }).catch((e) => {
                repositoryImportModal.showLoader = false;
                snackbarStore.createMessagesFromError(e);
              });
          }"
      />
    </Flex>
  </Flex>
</template>